<ngx-ui-loader></ngx-ui-loader>

<div class="container-fluid px-4">
    <div class="row my-3 mx-1">
        <div class="row">
            <div class="col-md-6">
                <h2 class="h2 ms-2 card-heading text-secondary">Iformbuilder Form</h2>
                <hr>
                <form (ngSubmit)="form_submit()" [formGroup]="clientForm">
                    <div class="row">
                        <div class="col-md-12">
                            <div class="mb-3">
                                <label for="exampleInputEmail1" class="form-label">Name<span
                                        class="text-danger">*</span></label>
                                <input type="text" class="form-control" formControlName="name">

                                <div *ngIf="clientForm.get('name')?.invalid && (clientForm.get('name')?.dirty && clientForm.get('name')?.touched)"
                                    class="text-danger">
                                    <div *ngIf="clientForm.get('name')?.errors?.['required']">
                                        This field is required.
                                    </div>
                                    <div *ngIf="clientForm.get('name')?.errors?.['minlength']">
                                        Minumum 3 character must be exist
                                    </div>
                                    <div *ngIf="clientForm.get('name')?.errors?.['maxlength']">
                                        Maximum 50 characters allowed
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="mb-3">
                                <label for="exampleInputEmail1" class="form-label">Email <span
                                        class="text-danger">*</span></label>
                                <input type="email" class="form-control" formControlName="email">
                                <div *ngIf="clientForm.get('email')?.invalid && (clientForm.get('email')?.dirty && clientForm.get('email')?.touched)"
                                    class="text-danger">
                                    <div *ngIf="clientForm.get('email')?.errors?.['required']">
                                        This field is required.
                                    </div>
                                    <div *ngIf="clientForm.get('email')?.errors?.['minlength']">
                                        Minumum 5 character must be exist
                                    </div>
                                    <div *ngIf="clientForm.get('email')?.errors?.['maxlength']">
                                        Maximum 50 characters allowed
                                    </div>
                                    <div *ngIf="clientForm.get('email')?.errors?.['email']">
                                        Email address is not valid.
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="mb-3">
                                <label for="exampleInputEmail1" class="form-label">Date of Birth <span
                                        class="text-danger">*</span></label>
                                <input type="text" class="form-control" formControlName="date_of_birth" bsDatepicker
                                    [bsConfig]="{ dateInputFormat: 'YYYY-MM-DD', returnFocusToInput: true }"
                                    [maxDate]="maxDate" readonly>
                                <div *ngIf="clientForm.get('date_of_birth')?.invalid && (clientForm.get('date_of_birth')?.dirty && clientForm.get('date_of_birth')?.touched)"
                                    class="text-danger">
                                    <div *ngIf="clientForm.get('date_of_birth')?.errors?.['required']">
                                        This field is required.
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="mb-3">
                                <label for="exampleInputEmail1" class="form-label">Birth Time<span
                                        class="text-danger">*</span></label>
                                <timepicker [formControlName]="'birth_time'"></timepicker>
                                <div *ngIf="clientForm.get('birth_time')?.invalid && (clientForm.get('birth_time')?.dirty && clientForm.get('birth_time')?.touched)"
                                    class="text-danger">
                                    <div *ngIf="clientForm.get('birth_time')?.errors?.['required']">
                                        This field is required.
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="mb-3">
                                <label for="exampleInputEmail1" class="form-label">Gender<span
                                        class="text-danger">*</span></label>
                                <div>
                                    <div class="form-check form-check-inline">
                                        <input class="form-check-input" type="radio" formControlName="gender"
                                            value="male" [checked]="true" id="male">
                                        <label class="form-check-label" for="male">Male</label>
                                    </div>
                                    <div class="form-check form-check-inline">
                                        <input class="form-check-input" type="radio" formControlName="gender"
                                            value="female" id="female">
                                        <label class="form-check-label" for="female">Female</label>
                                    </div>
                                    <div *ngIf="clientForm.get('gender')?.invalid && (clientForm.get('gender')?.dirty && clientForm.get('gender')?.touched)"
                                        class="text-danger">
                                        <div *ngIf="clientForm.get('gender')?.errors?.['required']">
                                            This field is required.
                                        </div>
                                    </div>
                                    
                                </div>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="mb-3">
                                <label for="exampleInputEmail1" class="form-label">Address<span
                                        class="text-danger">*</span></label>
                                <textarea type="text" class="form-control" formControlName="address"></textarea>
                                <div *ngIf="clientForm.get('address')?.invalid && (clientForm.get('address')?.dirty && clientForm.get('address')?.touched)"
                                    class="text-danger">
                                    <div *ngIf="clientForm.get('address')?.errors?.['required']">
                                        This field is required.
                                    </div>
                                    <div *ngIf="clientForm.get('address')?.errors?.['minlength']">
                                        Minumum 10 character must be exist
                                    </div>
                                    <div *ngIf="clientForm.get('address')?.errors?.['maxlength']">
                                        Maximum 100 characters allowed
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="mb-3">
                                <label for="exampleInputEmail1" class="form-label">Employee Strength<span
                                        class="text-danger">*</span> 
                                        <b>{{ this.clientForm.get('employees_in_company')?.value }}</b>
                                    </label>
                                <input type="range" class="form-range" min="10" max="500" step="1"
                                    formControlName="employees_in_company">
                                
                                <div *ngIf="clientForm.get('employees_in_company')?.invalid && (clientForm.get('employees_in_company')?.dirty && clientForm.get('employees_in_company')?.touched)"
                                    class="text-danger">
                                    <div *ngIf="clientForm.get('employees_in_company')?.errors?.['required']">
                                        This field is required.
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="mb-3">
                                <div class="form-check form-switch">
                                    <input class="form-check-input" type="checkbox" id="flexSwitchCheckDefault"
                                        formControlName="is_admin">
                                    <label class="form-check-label" for="flexSwitchCheckDefault">Is Admin<span
                                            class="text-danger">*</span></label>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="mb-3">
                                <div class="form-check">
                                    <label for="exampleInputEmail1" class="form-label">Hobby<span
                                            class="text-danger">*</span></label>
                                    <div formGroupName="hobby">
                                        <div class="form-check form-check-inline">
                                            <input class="form-check-input" type="checkbox" id="cricket" value="cricket"
                                                formControlName="cricket">
                                            <label class="form-check-label" for="cricket">Cricket</label>
                                        </div>
                                        <div class="form-check form-check-inline">
                                            <input class="form-check-input" type="checkbox" id="movie" value="movie"
                                                formControlName="movie">
                                            <label class="form-check-label" for="movie">Movie</label>
                                        </div>
                                        <div class="form-check form-check-inline">
                                            <input class="form-check-input" type="checkbox" id="reading" value="reading"
                                                formControlName="reading">
                                            <label class="form-check-label" for="reading">Reading</label>
                                        </div>
                                        <div class="form-check form-check-inline">
                                            <input class="form-check-input" type="checkbox" id="writing" value="writing"
                                                formControlName="writing">
                                            <label class="form-check-label" for="writing">Writing</label>
                                        </div>
                                    </div>

                                    <div *ngIf="clientForm.get('hobby')?.invalid && (clientForm.get('hobby')?.dirty && clientForm.get('hobby')?.touched)"
                                        class="text-danger">
                                        <div *ngIf="clientForm.get('hobby')?.errors?.['required']">
                                            This field is required.
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="mb-3">
                                <label for="exampleInputEmail1" class="form-label">Profile <span
                                        class="text-danger">*</span></label>
                                <input type="file" class="form-control" formControlName="profile"
                                    accept="image/png, image/jpeg, image/jpg" (change)="validateProfile($event)">
                                <div *ngIf="clientForm.get('profile')?.invalid && (clientForm.get('profile')?.dirty && clientForm.get('profile')?.touched)"
                                    class="text-danger">
                                    <div *ngIf="clientForm.get('profile')?.errors?.['required']">
                                        This field is required.
                                    </div>
                                    <div *ngIf="clientForm.get('profile')?.errors?.['type']">
                                        Profile picture must be a JPEG, JPG, PNG image.
                                    </div>
                                    <div *ngIf="clientForm.get('profile')?.errors?.['size']">
                                        Profile picture must be less then 2MB
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <button class="btn btn-primary" type="submit" [disabled]="clientForm.invalid">Submit</button>
                    
                </form>
            </div>
            <div class="col-md-6">
                <h2 class="h2 ms-2 card-heading text-secondary">Form Preview</h2>
                <hr>
                <div class="container h4" *ngIf="form_details.length != 0">
                    <div class="d-flex">
                        <label for="" class="pe-5 mb-3 col-md-4">Name:</label>
                        <div class="col-md-6">
                            {{ form_details?.name }}
                        </div>
                    </div>

                    <div class="d-flex">
                        <label for="" class="pe-5 mb-3 col-md-4">Email :</label>
                        <div class="col-md-6">
                            {{ form_details?.email }}
                        </div>
                    </div>

                    <div class="d-flex">
                        <label for="" class="pe-5 mb-3 col-md-4">DOB :</label>
                        <div class="col-md-6">
                            {{ form_details?.date_of_birth }}
                        </div>
                    </div>

                    <div class="d-flex">
                        <label for="" class="pe-5 mb-3 col-md-4">Gender:</label>
                        <div class="col-md-6">
                            {{ form_details?.gender }}
                        </div>
                    </div>

                    <div class="d-flex">
                        <label for="" class="pe-5 mb-3 col-md-4">Address:</label>
                        <div class="col-md-6">
                            {{ form_details?.address }}
                        </div>
                    </div>

                    <div class="d-flex">
                        <label for="" class="pe-5 mb-3 col-md-4">Employee Strength:</label>
                        <div class="col-md-6">
                            {{ form_details?.employees_in_company }}
                        </div>
                    </div>

                    <div class="d-flex">
                        <label for="" class="pe-5 mb-3 col-md-4">Is Admin:</label>
                        <div class="col-md-6">
                            {{ (form_details?.is_admin) ? "Yes" : 'No' }}
                        </div>
                    </div>

                    <div class="d-flex">
                        <label for="" class="pe-5 mb-3 col-md-4">Birth Time:</label>
                        <div class="col-md-6">
                            {{ form_details?.birth_time }}
                        </div>
                    </div>

                    <div class="d-flex">
                        <label for="" class="pe-5 mb-3 col-md-4">Hobby:</label>
                        <div class="col-md-6">
                            {{ form_details?.hobby }}
                        </div>
                    </div>

                    <div class="d-flex">
                        <label for="" class="pe-5 mb-3 col-md-4">Profile:</label>
                        <div class="col-md-6">
                            <a href="{{ form_details?.profile }}" target="_blank">Click here to fetch image url</a>
                            <br>
                            <span class="text-muted h6">[Note: Domain does not permitted to call the image URL and
                                getting CORS error. So, we unable to show image]</span>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>